//---------------------------------------------------------------------------
//	Takahiro Hayashi 2001.06.27
//	hayasita@na.rim.or.jp
//---------------------------------------------------------------------------

#include "shiori_dll.h"
#include "nasino.h"
#include "nasino_script.h"

ghost_data ghost_profile;								// GhostɊւf[^
ghost_memory communication_memory;						// Communication̋L

extern char LogTmp[AnswerLength];
extern int DicWordCount;						/* ̑vf */
extern unsigned int SentenceCount;				// sentence ̐


//---------------------------------------------------------------------------
//		SHIORI/2.0 request
//		requestĂɑĂ͂AsB
//
//		*answer		OUT		ԓ
//		*buffer		IN		͕
//---------------------------------------------------------------------------
int n_request(s20_data *answerdata,s20_data *commdata)
{
//	s20_data answerdata;			// SHIORI/2.0͌
	S23_ghost *ghost;

	logwrite("n_request\n");
	
//	s20decode(&commdata,buffer);
	
	nasino_script_main(commdata);		// nasino script s
	
//	printf("1\n");
	// ֐
	strcpy(communication_memory.sender,commdata->sender);
	strcpy(communication_memory.reference0,commdata->reference0);
	strcpy(communication_memory.reference1,commdata->reference1);
	strcpy(communication_memory.reference2,commdata->reference2);
	strcpy(communication_memory.reference3,commdata->reference3);
	strcpy(communication_memory.reference4,commdata->reference4);
	strcpy(communication_memory.reference5,commdata->reference5);
	strcpy(communication_memory.reference6,commdata->reference6);
	strcpy(communication_memory.reference7,commdata->reference7);
//	printf("2\n");
	
//	sprintf(LogTmp,"buffer:%s:\n",buffer);
//	logwrite(LogTmp);
	sprintf(LogTmp,"code:%d\n",commdata->code);
	logwrite(LogTmp);
	sprintf(LogTmp,"version:%d\n",commdata->version);
	logwrite(LogTmp);
	sprintf(LogTmp,"sender:%s:\n",commdata->sender);
	logwrite(LogTmp);
	sprintf(LogTmp,"ghost:%s:\n",commdata->ghost);
	logwrite(LogTmp);
	ghost = ghost_profile.ghost_pointer;
	while(ghost->ghost_name != NULL){
//		printf("Ghost Name: %d:%s\n",ghost->ghost_name,ghost->ghost_name);
		sprintf(LogTmp,"Ghost Name: %d:%s\n",ghost->ghost_name,ghost->ghost_name);
		logwrite(LogTmp);
		ghost = ghost->next_pointer;
	}
	sprintf(LogTmp,"charset:%s:\n",commdata->charset);
	logwrite(LogTmp);
	sprintf(LogTmp,"word:%s:\n",commdata->word);
	logwrite(LogTmp);
	sprintf(LogTmp,"sentence:%s:\n",commdata->sentence);
	logwrite(LogTmp);
	sprintf(LogTmp,"type:%s:\n",commdata->type);
	logwrite(LogTmp);
	sprintf(LogTmp,"id:%s:\n",commdata->id);
	logwrite(LogTmp);
	sprintf(LogTmp,"age:%d:\n",commdata->age);
	logwrite(LogTmp);
	sprintf(LogTmp,"event:%s:\n",commdata->event);
	logwrite(LogTmp);
	sprintf(LogTmp,"reference0:%s:\n",commdata->reference0);
	logwrite(LogTmp);
	sprintf(LogTmp,"reference1:%s:\n",commdata->reference1);
	logwrite(LogTmp);
	sprintf(LogTmp,"reference2:%s:\n",commdata->reference2);
	logwrite(LogTmp);
	sprintf(LogTmp,"reference3:%s:\n",commdata->reference3);
	logwrite(LogTmp);
	sprintf(LogTmp,"reference4:%s:\n",commdata->reference4);
	logwrite(LogTmp);
	sprintf(LogTmp,"reference5:%s:\n",commdata->reference5);
	logwrite(LogTmp);
	sprintf(LogTmp,"reference6:%s:\n",commdata->reference6);
	logwrite(LogTmp);
	sprintf(LogTmp,"reference7:%s:\n",commdata->reference7);
	logwrite(LogTmp);
	
	
	switch(commdata->code){
		case SHIORI_TEST:
			logwrite("-- Request SHIORI_TEST --\n");
			request_test(answerdata,commdata);
			break;
		case NOTIFY:
			logwrite("-- Request NOTIFY --\n");
			request_notify(answerdata,commdata);
			break;
		case NOTIFY_OtherGhostName:
			logwrite("-- Request NOTIFY_OtherGhostName --\n");
			printf("-- Request NOTIFY_OtherGhostName --\n");
			request_notify(answerdata,commdata);
			break;
		case GET_Version:
			logwrite("-- Request GET_Version --\n");
			request_version(answerdata);
			break;
		case GET_Sentence:
			logwrite("-- Request GET_Sentence --\n");
//			printf("-- Request GET_Sentence --\n");
			request_getsentence(answerdata,commdata);
			logwrite("-- Request GET_Sentence --\n");
			break;
		case GET_Word:
			logwrite("-- Request GET_Word --\n");
			request_getword(answerdata,commdata);
			break;
		case GET_Status:
			logwrite("-- Request GET_Status --\n");
			request_getssatus(answerdata,commdata);
			break;
		case COMMUNICATE_Sentence:
			logwrite("-- Request COMMUNICATE_Sentence --\n");
//			request_comsentence(answer,commdata);
			break;
		case GET_String:
			logwrite("-- Request GET_String --\n");
			request_getstring(answerdata,commdata);
			break;
		default:
			break;
	}
	
	return(OK);
}

//---------------------------------------------------------------------------
//		SHIORI/2.1 request COMMUNICATE_Sentence 
//		̓f[^ԓ쐬B
//
//		*answer					OUT		ԓ
//		s20_data commdata		IN		̓f[^
//---------------------------------------------------------------------------
int request_comsentence(char* answer,struct s20_data commdata)
{
	struct s20_data answerdata;
	int mode;
	int ret;
	
	s20_data_clear(&answerdata);

//	mode = nasino_s21communicate(&answerdata,commdata);										//
	mode = nasino_s20makeanswer(&answerdata,commdata);										//
	sprintf(LogTmp,"nasino_s20makeanswer:%s\n",answerdata.sentence);
	logwrite(LogTmp);

	if(mode == OK){
		strcpy(answerdata.sender,ghost_profile.sakuraname);
		answerdata.age = commdata.age + 1;
	}else{
		if(mode == NG){
			mode = kawari5com(answerdata.sentence,commdata.sentence);									//
			sprintf(LogTmp,"kawari5com:%d:%s\n",mode,answerdata.sentence);
			logwrite(LogTmp);
			if(mode == NG){
				n_getaistringfromtargetword(answerdata.sentence,commdata.sentence);		// ̏ꍇAŏ\ĥ̕ݎoāAɂɂイ̖҂Ă̂͂ǂB
				sprintf(LogTmp,"n_getaistringfromtargetword:%s\n",answerdata.sentence);
				logwrite(LogTmp);
			}
		}

		answerdata.code = 310;
		answerdata.version = 21;
		strcpy(answerdata.sender,ghost_profile.sakuraname);
		answerdata.age = commdata.age + 1;
	}
//	s22answer_encode(answer,answerdata);

	sprintf(LogTmp,"Answer:%s:\n",answer);
	logwrite(LogTmp);
	return(ret);
}

//---------------------------------------------------------------------------
// SHIORI/1.1 Comunicate
// SHIORI/2.3b
//---------------------------------------------------------------------------
int request_test(struct s20_data *answerdata,struct s20_data *commdata)
{
	int mode;
	int ret;
	
	s20_data_clear(answerdata);
	strcpy(commdata->sender,"");
	
	if(nasino_getghostname(answerdata->to,commdata) == OK){
		mode = nasino_s23ghostcomminucate(answerdata,commdata);										//
//		printf("nasino_s21communicate:%s\n",answerdata->sentence);
//		sprintf(LogTmp,"nasino_s21communicate:%s\n",answerdata->sentence);
//		logwrite(LogTmp);

		//Header
		answerdata->code = 200;
		answerdata->version = 23;
		// Sender:
		strcpy(answerdata->sender,ghost_profile.sakuraname);
		// Age:
		answerdata->age = 0;
		
		if(mode == OK){
			strcpy(answerdata->sentence,"\\hف[\\n\\w8CɓVn􂵂Ă邩H\\n\\e");
		}else{										// ėp̃Zt
			// Sentence:
//			make_sentence(answerdata.sentence,"\\hف[\\n\\w8C${n}Ă邩H\\n\\e",0);
			strcpy(answerdata->sentence,"\\hف[\\n\\w8CɓVn􂵂Ă邩H\\n\\e");
		}
		ret = OK;
	}else{
		//Header
		answerdata->code = 200;
		answerdata->version = 20;
		strcpy(answerdata->sentence,ST_NoOtherGhost);
		ret = NG;
	}
	
	return(ret);
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int request_notify(struct s20_data *answerdata,struct s20_data *commdata)
{
//	strcpy(ghost_profile.sakuraname,commdata.ghost);
//	request_answerheader_encode(answer,20,200);

	answerdata->code = 200;
	answerdata->version = 20;

//	sprintf(LogTmp,"GhostName:%s:\n",ghost_profile.sakuraname);
//	logwrite(LogTmp);
	
	return(OK);
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int request_version(struct s20_data *answerdata)
{
	
	answerdata->code = 200;
	answerdata->version = 25;
	
	return(OK);
}

//---------------------------------------------------------------------------
//		SHIORI/2.5 request getstring 
//		̓f[^ԓ쐬B
//		SHIORI/2.5͗łGetStringƂCxgƂB
//		reference0ɓB
//
//		s20_data *answer		OUT		ԓ
//		s20_data commdata		IN		̓f[^
//---------------------------------------------------------------------------
int request_getstring(struct s20_data *answerdata,struct s20_data *commdata)
{
	struct s20_data eventdata;
	
	s20_data_clear(&eventdata);
	
	eventdata.version = 22;						// SHIORI/2.2
	strcpy(eventdata.event,"GetString");		// GetStringCxgƂď
	strcpy(eventdata.reference0,commdata->id);	// Reference0IDݒ
	nasino_s22event(answerdata,&eventdata);
	answerdata->version = 25;					// SHIORI/2.5ɖ߂
	
//	s22answer_encode(answer,answerdata);
//	sprintf(LogTmp,"request_getstring:%s:\n",answer);
//	logwrite(LogTmp);
	
	return(OK);
}

//---------------------------------------------------------------------------
//		SHIORI/2.0,2.2 request getsentence 
//		̓f[^ԓ쐬B
//
//		*answer					OUT		ԓ
//		s20_data commdata		IN		̓f[^
//---------------------------------------------------------------------------
int request_getsentence(struct s20_data *answerdata,struct s20_data *commdata)
{
//	struct s20_data answerdata;
	int word_len;
	int sentence_len;
	int mode;

	printf("--- request_getsentence ---\n");
	s20_data_clear(answerdata);

	if(commdata->version == 20){									// GET Sentence SHIORI/2.0
		printf("S20Event\n");
		word_len = strlen(commdata->word);
		sentence_len = strlen(commdata->sentence);
		printf("\nrequest_getsentence : %d: %d\n",word_len,sentence_len);
		if(sentence_len > 0){		// sentence
			logwrite("Sentence\n");
			printf("sentence\n");
//			n_getresponse(answer_tmp,commdata.sentence);
			mode = nasino_s20get_sentence(answerdata,*commdata);										//
			if(mode == OK){
//				request_answerheader_encode(answer,answerdata->version,answerdata->code);
				answerdata->age = 0;
				strcpy(answerdata->sender,ghost_profile.sakuraname);
				logwrite("nasino_s20get_sentence\n");
			}
			if(mode == NG){
				n_getaistringfromtargetword(answerdata->sentence,commdata->sentence);
				answerdata->code = 200;
				answerdata->version = 20;
			}
		}else if(word_len > 0){		// word		p~?
			n_getaistringfromtargetword(answerdata->sentence,commdata->word);
			answerdata->code = 200;
			answerdata->version = 20;
		}else{						// n/a	sentenceɂ锭b
//			n_getword(answerdata->sentence,"sentence",0);
//			answerdata->code = 200;
//			answerdata->version = 20;
			get_tagword(commdata->buffer,"sentence");
			make_sentence2(answerdata,commdata,0);
			if(answerdata->version != 23){
				answerdata->version = 20;
				answerdata->code = 200;
			}
		}
	}else if(commdata->version == 22){							// GET Sentence SHIORI/2.2
//		printf("S22Event:%s\n",commdata->event);
		sprintf(LogTmp,"S22Event:%s\n",commdata->event);
		logwrite(LogTmp);
		nasino_s22event(answerdata,commdata);
//		printf("answerdata:%s\n",answerdata->sentence);
//		if(nasino_s22event(answerdata,commdata) == OK){
//			make_sentence(answerdata->sentence,answerdata->sentence,0);
//			answerdata->code = 200;
//			answerdata->version = 22;
//		}else{													// NGȂ204Ԃ
//			request_answerheader_encode(answer,22,204);
//			answerdata->code = 204;
//			answerdata->version = 22;
//		}
	}else if(commdata->version == 23){							// GET Sentence SHIORI/2.3b
//		strcpy(answerdata->sentence,"\\0ꂩȂ񂩌ĂB\\n\\w\\1܂Ȃ񂾂ȁB\\e");
		strcpy(commdata->to,commdata->sender);
		nasino_s23ghostcomminucate_new(answerdata,commdata);
		sprintf(LogTmp,"request_getsentence ghost_comm:%s:%s\n",commdata->sender,commdata->to);
		logwrite(LogTmp);
		answerdata->code = 200;
		answerdata->version = 23;
		if(strlen(commdata->to) != 0){
			strcpy(answerdata->to,commdata->sender);
		}else{
			strcpy(answerdata->to,"");							// bI
		}
		answerdata->age = commdata->age + 1;
	}
	
//	if((answerdata->version == 20) || (answerdata->version == 22)){
//		s22answer_encode(answer,answerdata);
//	}else if(answerdata->version == 23){
//		s23answer_encode(answer,answerdata);
//	}
//	sprintf(LogTmp,"request_getsentence:%s:\n",answer);
//	logwrite(LogTmp);
	
	return(OK);
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//int request_getword(char *answer,struct s20_data commdata)
int request_getword(struct s20_data *answerdata,struct s20_data *commdata)
{
	char keycode[WordLength];

	if(strlen(commdata->type) != 0){
		sprintf(keycode,"%s%s","compatible-",&(commdata->type[1]));		// ۂȂ̃pb`
		n_getword(answerdata->word,keycode,0);
	
		answerdata->version = 20;			// Header Version
		answerdata->code = 200;				// Header Code
	}else{
		answerdata->version = 20;			// Header Version
		answerdata->code = 204;				// Header Code
	}
	
	return(OK);
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//int request_getsSatus(char *answer,struct s20_data commdata)
int request_getssatus(struct s20_data *answerdata,struct s20_data *commdata)
{
	char answer_tmp[AnswerLength];
	char separater1[] = S20_Separater;
	
	answerdata->status[0] = ghost_profile.neuron = DicWordCount;
	answerdata->status[1] = ghost_profile.neuronm = SentenceCount;
	answerdata->status[2] = ghost_profile.neuronk = DicWordCount/3;		// ȉĂƁ[
	answerdata->status[3] = ghost_profile.neurond = DicWordCount/5;
	answerdata->status[4] = ghost_profile.neurone = DicWordCount/4;
	answerdata->status[5] = ghost_profile.sysnapse = DicWordCount/6;

	answerdata->code = 200;
	answerdata->version = 20;

//	request_answerheader_encode(answer,20,200);
//	sprintf(answer_tmp,"Status: %d,%d,%d,%d,%d,%d%s",ghost_profile.neuron,ghost_profile.neuronm,ghost_profile.neuronk,ghost_profile.neurond,ghost_profile.neurone,ghost_profile.sysnapse,separater1);
//	strcat(answer,answer_tmp);

	return(OK);
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int request_answerheader_encode(char *answer,int version,int status)
{
	char statuscode[AnswerHeaderLength];
	char separater1[] = S20_Separater;
	int ver_tmp;
	int ret;
	
	sprintf(answer,"SHIORI/%d.%d",version/10,version%10);
	
//	strcpy(answer,SHIORI_VERSION);
	switch(status){
		case 200:		// ɏI
			strcat(answer," 200 OK");
			strcat(answer,separater1);
			break;
		case 204:		// ɏIAԂׂf[^Ȃ
			strcat(answer," 204 No Content");
			strcat(answer,separater1);
			break;
		case 310:
			strcat(answer," 310 Communicate");
			strcat(answer,separater1);
			break;
		case 400:		// NGXgs
			strcat(answer," 400 Bad Request");
			strcat(answer,separater1);
			break;
		case 500:		// G[
			strcat(answer," 500 Internal Server Error");
			strcat(answer,separater1);
			break;
	}
	
	return(ret);
}


//---------------------------------------------------------------------------
//		SHIORI/2.0́̕B
//
//		*commdata		OUT		͌
//		*buffer			IN		͕
//---------------------------------------------------------------------------
int s20decode(struct s20_data *commdata,char *buffer)
{
	int count1;
	int ret;
	
	s20_data_clear(commdata);

	ret = s20header_decode(commdata,buffer);
//	sprintf(LogTmp,"code:%d\n",commdata->code);
//	logwrite(LogTmp);
	switch(commdata->code){
		case SHIORI_TEST:
			s20line_decode(commdata,buffer,S20_Sender);
			s20line_decode(commdata,buffer,S20_Charset);
			break;
		case NOTIFY:
			s20line_decode(commdata,buffer,S20_Sender);
			s20line_decode(commdata,buffer,S20_Ghost);
			s20line_decode(commdata,buffer,S20_Charset);
			break;
		case NOTIFY_OtherGhostName:
			s20line_decode(commdata,buffer,S20_Sender);
			s23ghost_decode(commdata,buffer);
			s20line_decode(commdata,buffer,S20_Charset);
			break;
		case GET_Version:
			s20line_decode(commdata,buffer,S20_Sender);
			s20line_decode(commdata,buffer,S20_Charset);
			break;
		case GET_Sentence:
			s20line_decode(commdata,buffer,S20_Sender);
			s20line_decode(commdata,buffer,S20_Charset);
			s20line_decode(commdata,buffer,S20_Word);
			s20line_decode(commdata,buffer,S20_Sentence);
			s20line_decode(commdata,buffer,S22_Event);
			s20reference_decode(commdata,buffer);
			break;
		case GET_Word:
			s20line_decode(commdata,buffer,S20_Sender);
			s20line_decode(commdata,buffer,S20_Charset);
			s20line_decode(commdata,buffer,S20_Word);
			s20line_decode(commdata,buffer,S20_Sentence);
			s20line_decode(commdata,buffer,S20_Type);
			break;
		case GET_Status:
			s20line_decode(commdata,buffer,S20_Sender);
			s20line_decode(commdata,buffer,S20_Charset);
			break;
		case COMMUNICATE_Sentence:
			s20line_decode(commdata,buffer,S20_Sender);
			s20line_decode(commdata,buffer,S20_Charset);
			s20line_decode(commdata,buffer,S20_Sentence);
			s20age_decode(commdata,buffer);
			break;
		case GET_String:										// SHIORI/2.5
			s20line_decode(commdata,buffer,S20_Sender);
			s20line_decode(commdata,buffer,S25_ID);
			s20line_decode(commdata,buffer,S20_Charset);
			break;
	}
			
	return(ret);
}

//---------------------------------------------------------------------------
//		SHIORI/2.0̃wb_(1s)fR[h
//		return		OUT		OK:fR[h		NG:fR[hs
//---------------------------------------------------------------------------
int s20header_decode(struct s20_data *commdata,char *buffer)
{
	char word[WordLength];
	char wordtmp[WordLength];
	int ret;
	
	getbufpword(word,buffer);
	if(strcmp(word,"TEST") == 0){
		commdata->code = SHIORI_TEST;
		ret = OK;
	}else if(strcmp(word,"NOTIFY") == 0){
		commdata->code = NOTIFY;
		getbufpword(word,buffer);
		if(strcmp(word,"OtherGhostName") == 0){
			commdata->code = NOTIFY_OtherGhostName;
			ret = OK;
		}else{
			ret = OK;
		}
	}else if(strcmp(word,"GET") == 0){
		getbufpword(word,buffer);
		if(strcmp(word,"Version") == 0){
			commdata->code = GET_Version;
			ret = OK;
		}else if(strcmp(word,"Sentence") == 0){
			commdata->code = GET_Sentence;
			ret = OK;
		}else if(strcmp(word,"Word") == 0){
			commdata->code = GET_Word;
			ret = OK;
		}else if(strcmp(word,"Status") == 0){
			commdata->code = GET_Status;
			ret = OK;
		}else if(strcmp(word,"String") == 0){			// SHIORI/2.5 GET String
			commdata->code = GET_String;
			ret = OK;
		}
	}else if(strcmp(word,"COMMUNICATE") == 0){
		getbufpword(word,buffer);
		if(strcmp(word,"Sentence") == 0){
			commdata->code = COMMUNICATE_Sentence;
			ret = OK;
		}
	}else{
		ret = NG;
	}

	getbufpword(word,buffer);
	if(strstr(word,"SHIORI/") != NULL){
		strcpy(&word[0],&word[7]);
		strcpy(&word[1],&word[2]);
		sprintf(LogTmp,"word:%s:\n",word);
		logwrite(LogTmp);
		commdata->version = atoi(word);
	}else{
		commdata->version = 0;
	}

	while((buffer[0]==0x0d || buffer[0]==0x0a) && strlen(buffer)>0){	/* 󔒂ǂݔ΂ */
		strcpy(&buffer[0],&buffer[1]);
	}

	return(ret);
}

//---------------------------------------------------------------------------
//		SHIORI/2.0̃wb_fR[h
//		return		OUT		OK:fR[h		NG:fR[hs
//---------------------------------------------------------------------------
int s20line_decode(struct s20_data *commdata,char *buffer,int com_number)
{
	char word[WordLength];
	char tag[WordLength];
	static char *command[] = { "Sender:","Ghost:","Charset:","Word:","Sentence:","Type:","Event:","ID:" };
	char *s20_datapoint[LineDecodeNum];
	
	s20_datapoint[S20_Sender]	= commdata->sender;
	s20_datapoint[S20_Ghost]	= commdata->ghost;
	s20_datapoint[S20_Charset]	= commdata->charset;
	s20_datapoint[S20_Word]		= commdata->word;
	s20_datapoint[S20_Sentence]	= commdata->sentence;
	s20_datapoint[S20_Type]		= commdata->type;
	s20_datapoint[S22_Event]	= commdata->event;
	s20_datapoint[S25_ID]		= commdata->id;
	
	char* point;
	int ret;
	
	point = strstr(buffer,command[com_number]);
	if(point != NULL){
		point += strlen(command[com_number]);

		getbufword0d(word,point);
		if(strlen(word) > 0){
			strcpy(s20_datapoint[com_number],word);
			ret = OK;
		}else{
			strcpy(s20_datapoint[com_number],"");
			ret = NG;
		}
	}else{
		strcpy(s20_datapoint[com_number],"");
		ret = NG;
	}
	
	return(ret);
}

//---------------------------------------------------------------------------
//		SHIORI/2.0̃wb_ Age:fR[h
//		return		OUT		OK:fR[h		NG:fR[hs
//---------------------------------------------------------------------------
int s20age_decode(struct s20_data *commdata,char *buffer)
{
	char word[WordLength];
	char* point;
	int ret;
	
	point = strstr(buffer,S23_AGE);
	if(point != NULL){
		point += 4;
		getbufword0d(word,point);
		if(strlen(word) > 0){
			commdata->age = atoi(word);
			ret = OK;
		}else{
			ret = NG;
		}
	}else{
		commdata->age = 0;
		ret = NG;
	}
	
	return(ret);
}

//---------------------------------------------------------------------------
//		SHIORI/2.0̃wb_ Reference:fR[h
//		return		OUT		n:fR[hőԍ		-1:fR[hs
//---------------------------------------------------------------------------
int s20reference_decode(struct s20_data *commdata,char *buffer)
{
	char word[WordLength];
	char reference[WordLength];
	char* point;
	int ret = -1;
	int count;
	char *reference_pointer[ReferenceNum];
	
	reference_pointer[0] = commdata->reference0;
	reference_pointer[1] = commdata->reference1;
	reference_pointer[2] = commdata->reference2;
	reference_pointer[3] = commdata->reference3;
	reference_pointer[4] = commdata->reference4;
	reference_pointer[5] = commdata->reference5;
	reference_pointer[6] = commdata->reference6;
	reference_pointer[7] = commdata->reference7;
	
	for(count = 0;count < ReferenceNum;count++){
		sprintf(reference,"Reference%d:",count);
		point = strstr(buffer,reference);
		if(point != NULL){
			point += strlen(reference);
			getbufword0d(word,point);
			if(strlen(word) > 0){
				strcpy(reference_pointer[count],word);
				ret = count;
			}else{
				strcpy(reference_pointer[count],"");
			}
		}else{
			strcpy(reference_pointer[count],"");
		}
	}
	
	return(ret);
}

//---------------------------------------------------------------------------
//		SHIORI/2.3̃wb_ GhostfR[h
//		return		OUT		OK:fR[h		NG:fR[hs
//---------------------------------------------------------------------------
void s23ghost_free(struct S23_ghost *ghost)
{
//	printf("0\n");
	if(ghost->next_pointer != NULL){
//		printf("1:ghost_name:%s\n",ghost->ghost_name);
		sprintf(LogTmp,"1:ghost_name:%s\n",ghost->ghost_name);
		logwrite(LogTmp);
		s23ghost_free(ghost->next_pointer);
//		printf("%d\n",ghost->next_pointer);
		sprintf(LogTmp,"%d\n",ghost->next_pointer);
		logwrite(LogTmp);
		free(ghost->next_pointer);
		ghost->next_pointer = NULL;
	}
	if(ghost->ghost_name != NULL){
//		printf("%d\n",ghost->ghost_name);
//		printf("2:ghost_name:%s\n",ghost->ghost_name);
		sprintf(LogTmp,"2:ghost_name:%s\n",ghost->ghost_name);
		logwrite(LogTmp);
		free(ghost->ghost_name);
		ghost->ghost_name = NULL;
	}
	ghost_profile.ghost_num = 0;	// l
	
	return;
}


int s23ghost_decode(struct s20_data *commdata,char *buffer)
{
	char word[WordLength];
	char wordtmp[WordLength];
//	char tag[WordLength];
	char *s20_datapoint[LineDecodeNum];
	
	
	char* point;
	int ret;
	
	char *buffer_tmp;
	char *line_buf;
	S23_ghost *ghost;
	
	ret = NG;
	
	if(( (buffer_tmp = (char*)malloc(strlen(buffer)+1)) == NULL) || ( (line_buf = (char*)malloc(strlen(buffer)+1)) == NULL)){
//		// malloc error.
		printf("malloc error!!\n");
		logwrite("s23ghost_decode!!\n");
	}else{
		logwrite("s23ghost_decode!!\n");
	
		strcpy(buffer_tmp,buffer);
	
		s23ghost_free(ghost_profile.ghost_pointer);
		ghost = ghost_profile.ghost_pointer;
		logwrite("s23ghost_free end!!\n");
		do{
			// s؂肾
			getbufword0d(line_buf,buffer_tmp);
			sprintf(LogTmp,"line_buf:%s\n",line_buf);
			logwrite(LogTmp);
//			printf("line_buf:%s\n",line_buf);
			strcpy(&buffer_tmp[0],&buffer_tmp[strlen(line_buf)+2]);
//			printf("buffer_tmp:%s\n",buffer_tmp);

//			getlineheader(word,line_buf);				// s̃wb_؂o
			getkeyword(word,line_buf);
//			printf("word:%s\n",word);
			
			if(strcmp(word,REQUEST_Header_GHOST) == 0){
				getsym(line_buf);						// : ̂Ă
				getbufword0d(word,line_buf);
				if(strlen(word) > 0){
//					printf("Ghost: %s\n",word);
					if( ((ghost->ghost_name = (char*)malloc(strlen(word)+1)) == NULL)
					 || ((ghost->next_pointer = (S23_ghost*)malloc(sizeof(S23_ghost))) == NULL) ){
//						// malloc error.
						printf("malloc error!!\n");
					}else{
						ghost_profile.ghost_num++;	// l
						strcpy(ghost->ghost_name,word);
						ghost->sakura_surface = -1;		// T[tFCXs
						ghost->kero_surface = -1;		// T[tFCXs
//						printf("Ghost: %d:%s\n",ghost->ghost_name,ghost->ghost_name);
						ghost = ghost->next_pointer;
						ghost->ghost_name = NULL;
						ghost->next_pointer = NULL;
//						logwrite("s23ghost_decode!!\n");
					}
					ret = OK;
				}
			}else if(strcmp(word,REQUEST_Header_GHOSTEX) == 0){
				getsym(line_buf);						// : ̂Ă
				getsym(line_buf);						//   ̂Ă@蔲ɂقǂB
				get01word(word,line_buf);
				if(strlen(word) > 0){
//					printf("GhostEx: %s:%s\n",word,line_buf);
					if( ((ghost->ghost_name = (char*)malloc(strlen(word)+1)) == NULL)
					 || ((ghost->next_pointer = (S23_ghost*)malloc(sizeof(S23_ghost))) == NULL) ){
//						// malloc error.
						printf("malloc error!!\n");
					}else{
						ghost_profile.ghost_num++;	// l
						strcpy(ghost->ghost_name,word);
						getsym(line_buf);			// 0x01̂
						get01word(word,line_buf);
//						printf("sakura_surface:%s\n",word);
						ghost->sakura_surface = atoi(word);
						getsym(line_buf);			// 0x01̂
						getbufword0d(word,line_buf);
//						printf("kero_surface:%s\n",word);
						ghost->kero_surface = atoi(word);
						
//						printf("Ghost: %d:%s\n",ghost->ghost_name,ghost->ghost_name);
						ghost = ghost->next_pointer;
						ghost->ghost_name = NULL;
						ghost->next_pointer = NULL;
//						logwrite("s23ghost_decode!!\n");
					}
					ret = OK;
				}
			}
		
		}while((strlen(buffer_tmp) != 0) && (strlen(line_buf) != 0));
		free(buffer_tmp);
		free(line_buf);


//#ifdef DEBUG_PRINT
		ghost = ghost_profile.ghost_pointer;
		while(ghost->ghost_name != NULL){
			printf("Ghost Name: %d:%s:%d:%d\n",ghost->ghost_name,ghost->ghost_name,ghost->sakura_surface,ghost->kero_surface);
			sprintf(LogTmp,"Ghost Name: %d:%s:%d:%d\n",ghost->ghost_name,ghost->ghost_name,ghost->sakura_surface,ghost->kero_surface);
			logwrite(LogTmp);
			ghost = ghost->next_pointer;
		}
		printf("%dl܂\n",ghost_profile.ghost_num);
//#endif

	}
	
	return(ret);
}

int s23ghost_decode_old(struct s20_data *commdata,char *buffer)
{
	char word[WordLength];
	char wordtmp[WordLength];
//	char tag[WordLength];
	char *s20_datapoint[LineDecodeNum];
	
	
	char* point;
	int ret;
	
	char *buffer_tmp;
	S23_ghost *ghost;
	
	ret = NG;
	
	if( (buffer_tmp = (char*)malloc(strlen(buffer)+1)) == NULL){
//		// malloc error.
		printf("malloc error!!\n");
		logwrite("s23ghost_decode!!\n");
	}else{
	
		strcpy(buffer_tmp,buffer);
	
		s23ghost_free(ghost_profile.ghost_pointer);
		ghost = ghost_profile.ghost_pointer;
		do{
//			printf("buffer_tmp:%s:\n",buffer_tmp);
//			point = strstr(buffer_tmp,S23_GHOST);
//			if(point != NULL){
			if((point = strstr(buffer_tmp,S23_GHOST)) != NULL){
				point += strlen(S23_GHOST);

				getbufword0d(word,point);
				if(strlen(word) > 0){
					printf("Ghost: %s\n",word);
					if( ((ghost->ghost_name = (char*)malloc(strlen(word)+1)) == NULL)
					 || ((ghost->next_pointer = (S23_ghost*)malloc(sizeof(S23_ghost))) == NULL) ){
//						// malloc error.
						printf("malloc error!!\n");
					}else{
						ghost_profile.ghost_num++;	// l
						strcpy(ghost->ghost_name,word);
//						printf("Ghost: %d:%s\n",ghost->ghost_name,ghost->ghost_name);
						ghost = ghost->next_pointer;
						ghost->ghost_name = NULL;
						ghost->next_pointer = NULL;
//						logwrite("s23ghost_decode!!\n");
					}
					ret = OK;
				}
				strcpy(buffer_tmp,point);
			}
		}while(point != NULL);
		free(buffer_tmp);


//#ifdef DEBUG_PRINT
		ghost = ghost_profile.ghost_pointer;
//		do{
		while(ghost->ghost_name != NULL){
			printf("Ghost Name: %d:%s\n",ghost->ghost_name,ghost->ghost_name);
			sprintf(LogTmp,"Ghost Name: %d:%s\n",ghost->ghost_name,ghost->ghost_name);
			logwrite(LogTmp);
			ghost = ghost->next_pointer;
		}
//		printf("%dl܂\n",ghost_profile.ghost_num);
//		}while(ghost->next_pointer != NULL);
//#endif

	}
	
	return(ret);
}

//---------------------------------------------------------------------------
//		f[^NA
//		return		OUT		OK:fR[h		NG:fR[hs
//---------------------------------------------------------------------------
int s20_data_clear(struct s20_data *commdata)
{
	int ret;
	ret = OK;
	
	commdata->code = 0;
	commdata->version = 0;
	strcpy(commdata->sender,"");
	strcpy(commdata->ghost,"");
	strcpy(commdata->charset,"");
	strcpy(commdata->word,"");
	strcpy(commdata->sentence,"");
	strcpy(commdata->type,"");
	commdata->status[0] = 0;
	commdata->status[1] = 0;
	commdata->status[2] = 0;
	commdata->status[3] = 0;
	commdata->status[4] = 0;
	commdata->status[5] = 0;
	strcpy(commdata->id,"");
	commdata->age = 0;
	strcpy(commdata->to,"");
	strcpy(commdata->targetHWnd,"");
	strcpy(commdata->event,"");
	strcpy(commdata->reference0,"");
	strcpy(commdata->reference1,"");
	strcpy(commdata->reference2,"");
	strcpy(commdata->reference3,"");
	strcpy(commdata->reference4,"");
	strcpy(commdata->reference5,"");
	strcpy(commdata->reference6,"");
	strcpy(commdata->reference7,"");
	
	return(ret);
}

//---------------------------------------------------------------------------
//		SHIORI/2.2̕ԓ쐬
//
//		char *answer				OUT		쐬ԓ
//		struct s20_data answerdata	IN		̓f[^
//---------------------------------------------------------------------------
int shiori_answer_encode(char *answer,struct s20_data answerdata,int type)
{
	char separater1[] = S20_Separater;
	char answer_tmp[AnswerLength];
	char answer_tmp2[AnswerLength];

	request_answerheader_encode(answer,answerdata.version,answerdata.code);		// Xe[^XR[h쐬
	if(answerdata.code != 204){
		switch(type){
			case GET_Version:
				sprintf(answer_tmp,"Charset: Shift_JIS%s",separater1);
				strcat(answer,answer_tmp);
				sprintf(answer_tmp,"ID: Nasino%sCraftman: T.Hayasaka%sVersion: 1.31.5%s",separater1,separater1,separater1);
				strcat(answer,answer_tmp);
				break;
			case NOTIFY:
			case NOTIFY_OtherGhostName:
				sprintf(answer_tmp,"Charset: Shift_JIS%s",separater1);
				strcat(answer,answer_tmp);
				break;
			case GET_Status:
				sprintf(answer_tmp,"Status: %d,%d,%d,%d,%d,%d%s",answerdata.status[0],answerdata.status[1],answerdata.status[2],answerdata.status[3],answerdata.status[4],answerdata.status[5],separater1);
				strcat(answer,answer_tmp);
				sprintf(answer_tmp,"Charset: Shift_JIS%s",separater1);
				strcat(answer,answer_tmp);
				break;
			case GET_String:
				sprintf(answer_tmp,"String: %s%s",answerdata.sentence,separater1);
				strcat(answer,answer_tmp);
				sprintf(answer_tmp,"Charset: Shift_JIS%s",separater1);
				strcat(answer,answer_tmp);
				break;
			case GET_Word:
				sprintf(answer_tmp,"Word: %s%s",answerdata.word,separater1);
				strcat(answer,answer_tmp);
				sprintf(answer_tmp,"Charset: Shift_JIS%s",separater1);
				strcat(answer,answer_tmp);
				break;
			case GET_Sentence:
			case SHIORI_TEST:
				if(answerdata.version == 23){
//					sprintf(answer_tmp,"Sender: %s%s",answerdata.sender,separater1);
					sprintf(answer_tmp,"Sender: %s%s",ghost_profile.sakuraname,separater1);
					strcat(answer,answer_tmp);
					sprintf(answer_tmp,"To: %s%s",answerdata.to,separater1);
					strcat(answer,answer_tmp);
					sprintf(answer_tmp,"Age: %d%s",answerdata.age,separater1);
					strcat(answer,answer_tmp);
				}
				sprintf(answer_tmp,"Sentence: %s%s",answerdata.sentence,separater1);
				strcat(answer,answer_tmp);
				sprintf(answer_tmp,"Charset: Shift_JIS%s",separater1);
				strcat(answer,answer_tmp);
				break;
			default:
				if(answerdata.code == 310){
					sprintf(answer_tmp,"Sender: %s%s",answerdata.sender,separater1);
					strcat(answer,answer_tmp);
//					sprintf(answer_tmp,"Charset: Shift_JIS%s",separater1);
//					strcat(answer,answer_tmp);
					sprintf(answer_tmp,"Age: %d%s",answerdata.age,separater1);
					strcat(answer,answer_tmp);
					if(strlen(answerdata.targetHWnd) != 0){
						sprintf(answer_tmp,"TargetHWnd: %s%s",answerdata.targetHWnd,separater1);
						strcat(answer,answer_tmp);
					}
				}
				if(answerdata.code != 204){
					sprintf(answer_tmp,"Sentence: %s%s",answerdata.sentence,separater1);
					strcat(answer,answer_tmp);
				}
				break;
		}
	}else{
		sprintf(answer_tmp,"Charset: Shift_JIS%s",separater1);
		strcat(answer,answer_tmp);
	}
	strcat(answer,separater1);

	return(OK);
}

/*
//---------------------------------------------------------------------------
//		SHIORI/2.2̕ԓ쐬
//
//		char *answer				OUT		쐬ԓ
//		struct s20_data answerdata	IN		̓f[^
//---------------------------------------------------------------------------
int s22answer_encode(char *answer,struct s20_data answerdata)
{
	char separater1[] = S20_Separater;
	char answer_tmp[AnswerLength];
	char answer_tmp2[AnswerLength];

	request_answerheader_encode(answer,answerdata.version,answerdata.code);		// Xe[^XR[h쐬
	if(answerdata.code == 310){
		sprintf(answer_tmp,"Sender: %s%s",answerdata.sender,separater1);
		strcat(answer,answer_tmp);
//		sprintf(answer_tmp,"Charset: Shift_JIS%s",separater1);
//		strcat(answer,answer_tmp);
		sprintf(answer_tmp,"Age: %d%s",answerdata.age,separater1);
		strcat(answer,answer_tmp);
		if(strlen(answerdata.targetHWnd) != 0){
			sprintf(answer_tmp,"TargetHWnd: %s%s",answerdata.targetHWnd,separater1);
			strcat(answer,answer_tmp);
		}
	}
	if(answerdata.code != 204){
		sprintf(answer_tmp,"Sentence: %s%s",answerdata.sentence,separater1);
		strcat(answer,answer_tmp);
	}

	return(OK);
}

//---------------------------------------------------------------------------
//		SHIORI/2.3̕ԓ쐬
//
//		char *answer				OUT		쐬ԓ
//		struct s20_data answerdata	IN		̓f[^
//---------------------------------------------------------------------------
int s23answer_encode(char *answer,struct s20_data answerdata)
{
	char separater1[] = S20_Separater;
	char answer_tmp[AnswerLength];
	char answer_tmp2[AnswerLength];

	request_answerheader_encode(answer,answerdata.version,answerdata.code);		// Xe[^XR[h쐬
	// SHIORI/2.3b
	if(answerdata.code == 200){
		sprintf(answer_tmp,"Sender: %s%s",answerdata.sender,separater1);
		strcat(answer,answer_tmp);
		sprintf(answer_tmp,"To: %s%s",answerdata.to,separater1);
		strcat(answer,answer_tmp);
		sprintf(answer_tmp,"Age: %d%s",answerdata.age,separater1);
		strcat(answer,answer_tmp);
		sprintf(answer_tmp,"Sentence: %s%s",answerdata.sentence,separater1);
		strcat(answer,answer_tmp);
		sprintf(answer_tmp,"Charset: Shift_JIS%s",separater1);
		strcat(answer,answer_tmp);
	}else if(answerdata.code != 204){
		sprintf(answer_tmp,"Sentence: %s%s",answerdata.sentence,separater1);
		strcat(answer,answer_tmp);
	}

	return(OK);
}
*/