//---------------------------------------------------------------------------
//	Takahiro Hayashi 2001.06.27
//	hayasita@na.rim.or.jp
//---------------------------------------------------------------------------

#include "nasino.h"

extern char LogTmp[AnswerLength];

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int getbufwordcat(char *word,unsigned char *sym,unsigned int *count1,unsigned int symbol_len)
{
	unsigned int ret;
	
	ret = ON;
	if((*count1+symbol_len) < WordLength){			// word̒͑B
		strcpy(&word[*count1],sym);
		#ifdef DEBUG_PRINT
//		printf("word2:%s:sym:%s\n",word,sym);
		#endif
		*count1 += symbol_len;
	}else{
		// G[
		printf("word OVERFLOW!\n");
		ret = OFF;
	}
	return(ret);
}

//---------------------------------------------------------------------------
// u""v̕o
//---------------------------------------------------------------------------
int getword_escape1(char *word,char *buffer,unsigned int *count1)
{
	unsigned char sym[3];
	unsigned int symbol_len;
	unsigned int ret;
	
	ret = ON;
	do{
		symbol_len = getsymsj(sym,buffer);
		if(symbol_len == 1){								// 1bytȅ
			if(sym[0] == '\\'){									// \B\͖̌̕Ŏ肱ށB
				getword_escape2(word,buffer,count1);
			}else if(sym[0] != '\"'){							// "ȊO̕
				ret = getbufwordcat(word,sym,count1,symbol_len);
			}
		}else if(symbol_len == 2){							// 2bytȅ
			ret = getbufwordcat(word,sym,count1,symbol_len);
		}
	}while((strlen(buffer)>0) && (sym[0] != '\"') && (ret != OFF));
	
	return(ret);
}

//---------------------------------------------------------------------------
//	<NAME>		getword_escape2
//
//	<FUNCTION>	GXP[vV[PX̂Q
//
//		char *word					IN/OUT		o͕
//		char *buffer				IN/OUT		͕
//		unsigned int	*count1		IN/OUT		*word̕
//		return(int)					OUT			ON : I
//												OFF: ُI *word̃I[o[t[
//	u\v̌̕肱ޏB
//	*buffer̐擪̈ꕶ*wordɉB
//
//---------------------------------------------------------------------------
int getword_escape2(char *word,char *buffer,unsigned int *count1)
{
	unsigned char sym[3];
	unsigned int symbol_len;
	unsigned int ret;
	
	ret = ON;
	symbol_len = getsymsj(sym,buffer);

	if(symbol_len == 1){								// 1bytȅ
		if(sym[0] == '\\'){									// \B\̌̕n,ȑꍇ͓ꏈB
			symbol_len = chksymsj(sym,buffer);
			if(symbol_len == 1){								// 1bytȅ
				if(sym[0] == 'n'){
					symbol_len = getsymsj(sym,buffer);
					strcpy(sym,"\n");
				}else if(sym[0] == 'r'){
					symbol_len = getsymsj(sym,buffer);
					strcpy(sym,"\r");
				}
			}
		}
	}

	ret = getbufwordcat(word,sym,count1,symbol_len);
	
	return(ret);
}


//---------------------------------------------------------------------------
//	<NAME>		getsignword
//
//	<FUNCTION>	_Z̉Zqo
//
//	char *buffer			͕
//	char *word				oword
//	return word̏Ipointer
//
//	񂩂擪̉ZL؂oB
//	ZĹu,()&|!^vƂB
//	*buffer͐؂ꂽAOɋl߂B
//	̑Oɂu vu\tv͖B
//---------------------------------------------------------------------------
int getsignword(char *word,char *buffer)
{
	int count=0;

//	printf("buffer:%s",buffer);
//	read_space(buffer);				// buffer擪 ' ' , '\t' , ',' B
	while((buffer[0]==' ' || buffer[0]=='\t'/* || buffer[0]==','*/) && strlen(buffer)>0){	/* 󔒂ǂݔ΂B','͔΂ȂB */
		strcpy(&buffer[0],&buffer[1]);
	}

	if(buffer[0]==','
	|| buffer[0]=='(' || buffer[0]==')' || buffer[0]=='&' || buffer[0]=='|' || buffer[0]=='!' || buffer[0]=='^'){
		word[count]=buffer[0];
		strcpy(&buffer[0],&buffer[1]);
		count=count+1;
	}
	
	word[count]='\0';

	word_rspacecut(word);		/* s'\n'' ''\t'͎菜 */
//	printf("buffer:%s",buffer);

	return count;

}

//---------------------------------------------------------------------------
//		_Z̃[h؂oBbufferj󂷂B
//
//		*word		OUT		^O
//		*buffer		IN		͕
//		ret			OUT		OK:^O؂肾 NG:^O͔łȂB
//---------------------------------------------------------------------------
/*
	char *buffer			͕
	char *word				oword
	return word̏Ipointer

񂩂牉Zq؂oB
*buffer͐؂ꂽAOɋl߂B
̑Oɂu vu\tv͖B
ZqƁu\tvu,vu\0vu\nvu0x0dv؂蕶ƂB
u\v̓GXP[vƂA1͖Ɏ肱܂B
u""v̊Ԃ́̕u\vGXP[vƂȊO͖Ɏ肱܂B
ShiftJIS΍
*/
int getcalcword(char *word,char *buffer_tmp)
//int getcalcword(char *word,char *buffer)
{
	unsigned int count1;
	unsigned int loop;
	unsigned char sym[3];
	unsigned int symbol_len;
	char buffer[DicBufferLength];
//	char *buffer = NULL;
	
//	read_space(buffer);				// buffer擪 ' ' , '\t' , ',' B// getsignword()ɂ点B

	strcpy(word,"");
	getsignword(word,buffer_tmp);				// 擪̉ZqT
	if(strlen(word) == 0){
//	if(getsignword(word,buffer_tmp) != 0){
//printf("buffer_tmp:%s:%d\n",buffer_tmp,strlen(buffer_tmp) + 1);
//		if((buffer = (char*)malloc(strlen(buffer_tmp) + 1)) == NULL){
//			printf("Error!!\n");
//		}else{
//			
//		}
//printf("buffer_tmp:%s\n",buffer_tmp);
		strcpy(buffer,buffer_tmp);
//printf("buffer_tmp:%s\n",buffer_tmp);
		
		count1 = 0;
		loop = ON;
		do{
			symbol_len = getsymsj(sym,buffer);
			if(symbol_len == 1){							// 1bytȅ
				if(sym[0] == '\"'){								// "B""Ԃ͖̕Ŏ肱ށB
					loop = getword_escape1(word,buffer,&count1);
				}else if(sym[0] == '\\'){						// \B\̌̈ꕶ͖Ŏ肱ށB
					getword_escape2(word,buffer,&count1);
				}else if( (sym[0] == ',') || (sym[0] == '\t') || (sym[0] == '\0') || (sym[0] == '\n') || (sym[0] == 0x0d) 
						|| sym[0]=='(' || sym[0]==')' || sym[0]=='&' || sym[0]=='|' || sym[0]=='!' || sym[0]=='^' ){
					loop = OFF;
				}else{
					loop = getbufwordcat(word,sym,&count1,symbol_len);
				}
				#ifdef DEBUG_PRINT
//				printf("word1:%s:sym:%s\n",word,sym);
//				printf("buffer:%s:word1:%s:sym:%s\n",buffer,word,sym);
				#endif
			}else if(symbol_len == 2){						// 2bytȅ
				loop = getbufwordcat(word,sym,&count1,symbol_len);
			}
		}while((strlen(buffer)>0) && (loop == ON));
		word[count1]='\0';
	
		word_rspacecut(word);		/* s'\n'' ''\t'͎菜 */
	
		symbol_len = strlen(word);
		strcpy(buffer_tmp,&buffer_tmp[symbol_len]);
		
//		free(buffer);
	}	
	
	#ifdef DEBUG_PRINT
//	printf("word:%s:\n",word);
	#endif
	return count1;

}

//---------------------------------------------------------------------------
//	<NAME>		getbufword
//
//	<FUNCTION>	񂩂o
//
//	char *buffer				IN		͕
//	char *word					OUT		oword
//	return word̏Ipointer	OUT
//
//	񂩂؂oB
//	*buffer͐؂ꂽAOɋl߂B
//	̑Oɂu vu\tvu,v͖B
//	u\tvu,vu\0vu\nvu0x0dv؂蕶ƂB
//	u""v̊Ԃ́̕u\vGXP[vƂȊO͖Ɏ肱܂B
//	u\v̓GXP[vƂA1͖Ɏ肱܂B
//	悤ɂSAKURAXNvg\ĤłȂB
//	ShiftJIS΍
//	
//---------------------------------------------------------------------------
int getbufword(char *word,char *buffer)
{
	unsigned int count1;
	unsigned int loop;
	unsigned char sym[3];
	unsigned int symbol_len;

	read_space(buffer);				// buffer擪 ' ' , '\t' , ',' B

	count1 = 0;
	loop = ON;
	do{
		symbol_len = getsymsj(sym,buffer);
		if(symbol_len == 1){							// 1bytȅ
			if(sym[0] == '\"'){								// "B""Ԃ͖̕Ŏ肱ށB
				loop = getword_escape1(word,buffer,&count1);
//			}else if(sym[0] == '\\'){								// \B""Ԃ͖̕Ŏ肱ށB
//				getword_escape2(word,buffer,&count1);
			}else if( (sym[0] == ',') || (sym[0] == '\t') || (sym[0] == '\0') || (sym[0] == '\n') || (sym[0] == 0x0d) ){
				loop = OFF;
			}else{
				loop = getbufwordcat(word,sym,&count1,symbol_len);
//				if((count1+symbol_len) < WordLength){			// word̒͑邩B
//					strcpy(&word[count1],sym);
//					count1 += symbol_len;
//				}else{
//					printf("word OVERFLOW!\n");
//					loop = OFF;
//				}
			}
//			#ifdef DEBUG_PRINT
//			printf("word1:%s:sym:%s\n",word,sym);
//			printf("buffer:%s:word1:%s:sym:%s\n",buffer,word,sym);
//			#endif
		}else if(symbol_len == 2){						// 2bytȅ
			loop = getbufwordcat(word,sym,&count1,symbol_len);
//			if((count1+symbol_len) < WordLength){			// word̒͑B
//				strcpy(&word[count1],sym);
//				#ifdef DEBUG_PRINT
////				printf("word2:%s:sym:%s\n",word,sym);
//				#endif
//				count1 += symbol_len;
//			}else{
//				printf("word OVERFLOW!\n");
//				loop = OFF;
//			}
		}
	}while((strlen(buffer)>0) && (loop == ON));
	word[count1]='\0';

	word_rspacecut(word);		/* s'\n'' ''\t'͎菜 */

	#ifdef DEBUG_PRINT
//	printf("word:%s:\n",word);
	#endif
	return count1;

}


//---------------------------------------------------------------------------
/*	<NAME>		getkeyword													*/
/*																			*/
/*	<FUNCTION>	񂩂󔒂ŋ؂邩":"̑O܂ł̈o		*/
//---------------------------------------------------------------------------
int getkeyword_one(char *word,char *buffer)
/*
	char *buffer			͕
	char *word				oword
	return word̏Ipointer

񂩂؂oB
*buffer͐؂ꂽAOɋl߂B
̑Oɂu vu\tvu,v͖B
u vu\tvu,vu\0vu\nvu:v؂蕶ƂB
*/
{
	unsigned int count1;
	unsigned int loop;
	unsigned int loop2;
	unsigned char sym[3];
	unsigned int symbol_len;

	read_space(buffer);				// buffer擪 ' ' , '\t' , ',' B

	count1 = 0;
	loop = ON;
	do{
		symbol_len = getsymsj(sym,buffer);
		if(symbol_len == 1){							// 1bytȅ
			if(sym[0] == '\"'){								// "B""Ԃ͖̕Ŏ肱ށB
				loop = getword_escape1(word,buffer,&count1);
			}else if(sym[0] == '['){						// []B[]̊Ԃ͖Ŏ荞ށB
				loop = getbufwordcat(word,sym,&count1,symbol_len);
				loop2 = ON;
				do{
					symbol_len = getsymsj(sym,buffer);
					if(symbol_len == 1){
						if(sym[0] == ']'){
							loop = getbufwordcat(word,sym,&count1,symbol_len);
							loop2 = OFF;
						}else if(sym[0] == '\"'){								// "B""Ԃ͖̕Ŏ肱ށB
							loop = getword_escape1(word,buffer,&count1);
						}else{
							loop = getbufwordcat(word,sym,&count1,symbol_len);
						}
					}else{
						loop = getbufwordcat(word,sym,&count1,symbol_len);
					}
				}while((loop == ON) && (loop2 == ON));
			}else if( (sym[0] == ':') || (sym[0] == ' ') || (sym[0] == ',') || (sym[0] == '\t') || 
					  (sym[0] == '\0') || (sym[0] == '\n') || (sym[0] == 0x0d) ){
				loop = OFF;
			}else{
				loop = getbufwordcat(word,sym,&count1,symbol_len);
			}
			#ifdef DEBUG_PRINT
//			printf("word1:%s:sym:%s\n",word,sym);
//			printf("buffer:%s:word1:%s:sym:%s\n",buffer,word,sym);
			#endif
		}else if(symbol_len == 2){						// 2bytȅ
			loop = getbufwordcat(word,sym,&count1,symbol_len);
		}
	}while((strlen(buffer)>0) && (loop == ON));
	word[count1]='\0';

	word_rspacecut(word);		/* s'\n'' ''\t'͎菜 */

	#ifdef DEBUG_PRINT
//	printf("word:%s:\n",word);
	#endif
	return count1;

}

/****************************************************************************/
/*	<NAME>		getkeyword													*/
/*																			*/
/*	<FUNCTION>	񂩂󔒂ŋ؂邩":"̑O܂ł̈o		*/
/****************************************************************************/
int getkeyword(char *word,char *buffer)
/*
	char *buffer			͕
	char *word				oword
	return word̏Ipointer

񂩂؂oB
*buffer͐؂ꂽAOɋl߂B
̑Oɂu vu\tvu,v͖B
u vu\tvu,vu\0vu\nvu:v؂蕶ƂB
*/
{
	int count=0;

	while((buffer[0]==' ' || buffer[0]=='\t'/* || buffer[0]==','*/) && strlen(buffer)>0){	/* 󔒂ǂݔ΂ */
		strcpy(&buffer[0],&buffer[1]);
	}
/*	while(buffer[0]!=' ' && buffer[0]!='\t' && buffer[0]!=',' && buffer[0]!='\0'
	&& buffer[0]!='\n' && buffer[0]!=':'){	/* ̋؂蕶܂ł̕؂o */
	while(buffer[0]!=':'  && buffer[0]!='\0' && strlen(buffer)>0){					/* ̋؂蕶܂ł̕؂o */
		word[count]=buffer[0];
		strcpy(&buffer[0],&buffer[1]);
		count=count+1;
	}
	word[count]='\0';

	while((word[count-1]=='\t') || (word[count-1]==' ')){		/* s'\n'' '͎菜 */
		count = count -1;
		word[count]='\0';
	}

	return count;

}

//---------------------------------------------------------------------------
//		0x01܂ł؂o
//
//		*word		OUT		^O
//		*buffer		IN		͕
//		ret			OUT		OK:^O؂肾 NG:^O͔łȂB
//---------------------------------------------------------------------------
int get01word(char *word,char *buffer)
{
	int count =0;
	
//	while((buffer[0]==0x01) && strlen(buffer)>0){	/* 󔒂ǂݔ΂ */
//		strcpy(&buffer[0],&buffer[1]);
//	}
	while(buffer[0]!= 0x01 && buffer[0]!= '\0'){	/* ̋؂蕶܂ł̕؂o */
		word[count]=buffer[0];
		strcpy(&buffer[0],&buffer[1]);
		count=count+1;
	}
	word[count]='\0';
	
	return(count);
}

//---------------------------------------------------------------------------
//		̐擪A^O1؂o
//
//		*word		OUT		^O
//		*buffer		IN		͕
//		ret			OUT		OK:^O؂肾 NG:^O͔łȂB
//---------------------------------------------------------------------------
int gettagword(char *word,char *buffer)
{
	int ret;
	int temp;
	char *point;
	
	point = strstr2(buffer,START_TAG0);
	if(point != NULL){
		strcpy(buffer,point);
//		printf("gettagword:%s\n",buffer);
		
		point = strstr2(buffer,END_TAG0);
		temp = point - buffer + 1;
		memcpy(word,buffer,temp);
		word[temp] = '\0';
//		printf("gettagword:%s:\n",word);
		
		ret = OK;
	}else{
		ret = NG;
	}
	
	return(ret);
}

/****************************************************************************/
/*	<NAME>		getmarkword													*/
/*																			*/
/*	<FUNCTION>	":"܂ł̕o									*/
/****************************************************************************/
int getmarkword(char *word,char *buffer)
/*
	char *buffer			͕
	char *word				oword
	return word̏Ipointer

񂩂؂oB
*buffer͐؂ꂽAOɋl߂B
̑Oɂu vu\tvu,v͖B
u vu\tvu,vu\0vu\nvu:v؂蕶ƂB
*/
{
	int count=0;
	int loop = ON;
	int ret = NG;

	while((buffer[0]==' ' || buffer[0]=='\t' || buffer[0]==',') && strlen(buffer)>0){	/* 󔒂ǂݔ΂ */
		strcpy(&buffer[0],&buffer[1]);
	}
	
	do{
		if(buffer[0] == ':'){
			loop = OFF;
			ret = OK;
		}
		word[count]=buffer[0];
		strcpy(&buffer[0],&buffer[1]);
		count=count+1;
	}while(buffer[0]!=' ' && buffer[0]!='\t' && buffer[0]!=',' && buffer[0]!='\0'
	&& buffer[0]!='\n' && loop == ON /*buffer[0]!=':'*/);	/* ̋؂蕶܂ł̕؂o */

	word[count]='\0';

	return(ret);

}

/****************************************************************************/
/*	<NAME>		getbufpword													*/
/*																			*/
/*	<FUNCTION>	񂩂o									*/
/****************************************************************************/
int getbufpword(char *word,char *buffer)
/*
	char *buffer			͕
	char *word				oword
	return word̏Ipointer

񂩂؂oB
*buffer͐؂ꂽAOɋl߂B
̑Oɂu vu\tvu,v͖B
u vu\tvu,vu\0vu\nvu=v؂蕶ƂB
*/
{
	int count=0;

	while((buffer[0]==' ' || buffer[0]=='\t' || buffer[0]==',') && strlen(buffer)>0){	/* 󔒂ǂݔ΂ */
		strcpy(&buffer[0],&buffer[1]);
	}
	while(buffer[0]!=' ' && buffer[0]!='\t' && buffer[0]!=',' && buffer[0]!='\0'
	&& buffer[0]!='\n' && buffer[0]!=0x0d /*&& buffer[0]!='='*/){	/* ̋؂蕶܂ł̕؂o */
		word[count]=buffer[0];
		strcpy(&buffer[0],&buffer[1]);
		count=count+1;
	}
	
	word[count]='\0';

	word_rspacecut(word);

	return count;

}


/****************************************************************************/
/*	<NAME>		getbufp2word												*/
/*																			*/
/*	<FUNCTION>	񂩂0x0d܂ł̕o						*/
/****************************************************************************/
int getbufword0d(char *word,char *buffer_point)
/*
	char *buffer			͕
	char *word				oword
	return word̏Ipointer

buffer_point0x0d܂ł̕܂ł؂oB
*buffe̓e͑삵ȂB
̑Oɂu vu\tvu,v͖B
*/
{
	int count=0;

	while((*buffer_point==' ' || *buffer_point=='\t' || *buffer_point==',') && strlen(buffer_point)>0){	/* 󔒂ǂݔ΂ */
		buffer_point++;
	}
	while(*buffer_point!='\0' && *buffer_point!=0x0d){	/* ̋؂蕶܂ł̕؂o */
		word[count]=*buffer_point;
		buffer_point++;
		count=count+1;
	}
	word[count]='\0';
	word_rspacecut(word);

	return count;

}

/****************************************************************************/
/*	<NAME>		getbufconditional											*/
/*																			*/
/*	<FUNCTION>	񂩂[]ň͂܂ꂽo						*/
/****************************************************************************/
int getbufconditional(char *word,char *buffer_point)
/*
	char *buffer			͕
	char *word				oword
	return word̏Ipointer

buffer_point[]ň͂܂ꂽ܂ł؂oB
*buffe̓e͑삵ȂB
̑Oɂu vu\tvu,v͖B
؂蕶́u]v
*/
{
	int count=0;

	while((*buffer_point!='[') && strlen(buffer_point)>0){	/* 󔒂ǂݔ΂ */
		buffer_point++;
	}
	buffer_point++;											// [ ΂
	do{
		word[count]=*buffer_point;
		buffer_point++;
		count=count+1;
	}while(*buffer_point!='\0' && *buffer_point!=']' );		/* ̋؂蕶܂ł̕؂o */
//	}while(*buffer_point!='\0' && (*buffer_point!=']' || (checksjcode(*(buffer_point-1))==NG)) );		/* ̋؂蕶܂ł̕؂o */
//	word[count]=*buffer_point;
//	count=count+1;
	word[count]='\0';
	word_rspacecut(word);

	return count;

}


/****************************************************************************/
/*	<NAME>		getbufentry													*/
/*																			*/
/*	<FUNCTION>	񂩂${}ň͂܂ꂽo						*/
/****************************************************************************/
int getbufentry(char *word,char *buffer_point)
/*
	char *buffer			͕
	char *word				oword
	return word̏Ipointer

buffer_point[]ň͂܂ꂽ܂ł؂oB
*buffe̓e͑삵ȂB
̑Oɂu vu\tvu,v͖B
؂蕶́u]v
*/
{
	int count=0;
	int ret;

	while(((*buffer_point!='$') && ((*buffer_point+1)!='{')) && strlen(buffer_point)>1){	/* ${ǂݔ΂ */
		buffer_point++;
	}
	if(strlen(buffer_point)>1){
		buffer_point += 2;											// ${ ΂
		while((*buffer_point==' ' || *buffer_point=='\t') && strlen(buffer_point)>0){	/* 󔒂ǂݔ΂ */
			buffer_point++;
		}
//		do{
		while(*buffer_point!='\0' && *buffer_point!='}'){		/* ̋؂蕶܂ł̕؂o */
			word[count]=*buffer_point;
			buffer_point++;
			count=count+1;
		}
//		}while(*buffer_point!='\0' && *buffer_point!='}');		/* ̋؂蕶܂ł̕؂o */
		word[count]='\0';
		word_rspacecut(word);
		if(strlen(word) > 0){
			ret = OK;
		}else{
			ret = NG;
		}
	}else{
		ret = NG;
	}
	printf("count:%d\n",count);

	return(ret);

}


/****************************************************************************/
/*	<NAME>		getnumberword												*/
/*																			*/
/*	<FUNCTION>	񂩂琔l݂̂̈o							*/
/****************************************************************************/
int getnumberword(char *word,char *buffer)
/*
	char *buffer			͕
	char *word				oword
	return word̏Ipointer
񂩂琔l݂̂̈o
*/
{
	int count=0;

	while((buffer[0]==' ' || buffer[0]=='\t' || buffer[0]==',') && strlen(buffer)>0){	/* 󔒂ǂݔ΂ */
		strcpy(&buffer[0],&buffer[1]);
	}
	while((buffer[0]<'0' || buffer[0]>'9') && strlen(buffer)>0){		/* lȊOǂݔ΂ */
		strcpy(&buffer[0],&buffer[1]);
	}
	while(buffer[0]>='0' && buffer[0]<='9'){	/* l؂o */
		word[count]=buffer[0];
		strcpy(&buffer[0],&buffer[1]);
		count=count+1;
	}
	word[count]='\0';

	return count;

}

/****************************************************************************/
/*	<NAME>		getsym														*/
/*																			*/
/*	<FUNCTION>	V{1o										*/
/****************************************************************************/
char getsym(char *buffer)
/*
	char *buffer			͕
	return(sym)				oV{
V{1o
*/
{
	char sym;

	sym = buffer[0];
	strcpy(&buffer[0],&buffer[1]);
	return(sym);
}

//---------------------------------------------------------------------------
//	<NAME>		getsymsj
//
//	<FUNCTION>	V{1؂o S-JISR[hΉ
//				buffer͐؂oꂽOɋl߂B
//
//	char *buffer	IN		͕
//	char *sym		OUT		o
//	return			OUT		obyte
//---------------------------------------------------------------------------
int getsymsj(char *sym,char *buffer)
{
	int ret;

	if(strlen(buffer) > 0){
		if(checksjcode(buffer[0]) == OK){
//			S-JIS
			sym[0] = buffer[0];
			sym[1] = buffer[1];
			sym[2] = '\0';
			strcpy(&buffer[0],&buffer[2]);
			ret = 2;
		}else{
//			1byte
			sym[0] = buffer[0];
			sym[1] = '\0';
			strcpy(&buffer[0],&buffer[1]);
			ret = 1;
		}
	}else{
		ret = 0;
	}

	return(ret);
}

//---------------------------------------------------------------------------
//	<NAME>		chksymsj
//
//	<FUNCTION>	V{1؂o S-JISR[hΉ
//				buffer̓e͕ωȂB
//
//	char *buffer	IN		͕
//	char *sym		OUT		o
//	return			OUT		obyte
//---------------------------------------------------------------------------
int chksymsj(char *sym,char *buffer)
{
	int ret;

	if(strlen(buffer) > 0){
		if(checksjcode(buffer[0]) == OK){
//			S-JIS
			sym[0] = buffer[0];
			sym[1] = buffer[1];
			sym[2] = '\0';
			ret = 2;
		}else{
//			1byte
			sym[0] = buffer[0];
			sym[1] = '\0';
			ret = 1;
		}
	}else{
		ret = 0;
	}

	return(ret);
}

/****************************************************************************/
/*	<NAME>		read_space													*/
/*																			*/
/*	<FUNCTION>	󔒕ǂݔ΂											*/
/****************************************************************************/
void read_space(char *buffer)
/*
	char *buffer	͕
	
	return			
󔒁i' ','\t',','jǂݔ΂B
*/
{
	while(buffer[0]==' ' || buffer[0]=='\t' || buffer[0]==','){	/* 󔒂ǂݔ΂ */
		strcpy(&buffer[0],&buffer[1]);
	}
	return;
}

/****************************************************************************/
/*	<NAME>		str_toupper													*/
/*																			*/
/*	<FUNCTION>	啶ɕϊ									*/
/****************************************************************************/
void str_toupper(char *buffer2,char *buffer)
/*
	char *buffer	͕
	
	return			
ׂđ啶ɕϊB
*/
{
	unsigned int count;
	
	for(count=0;count<=strlen(buffer);count++){
		buffer2[count] = toupper(buffer[count]);
	}
	return;
}

/****************************************************************************/
/*	<NAME>		check_onoff													*/
/*																			*/
/*	<FUNCTION>	ON,OFFǂ炩ׂ								*/
/****************************************************************************/
int check_onoff(char *word)
{
	int ret;
	char tmp_word[DataLength];				/* ؂odata */

	str_toupper(tmp_word,word);
	if(strcmp(tmp_word,"ON") == 0){
		ret = ON;
		printf("ret ON : %s\n",word);
	}else{
		printf("ret OFF : %s\n",word);
		ret = OFF;
	}

	return(ret);
}

//---------------------------------------------------------------------------
//		wordI[̋󔒂폜
//
//		*word		IN		͕
//---------------------------------------------------------------------------
void word_rspacecut(char *word)
{
	int count;
	
	count = strlen(word);
	while((word[count-1]=='\n') || (word[count-1]==' ') || (word[count-1]=='\t')){		/* s'\n'' ''\t'͎菜 */
		count = count -1;
		word[count]='\0';
	}
	
	return;
}

//---------------------------------------------------------------------------
//		_Z
//
//		*word		IN		_
//		int return	OUT		
//---------------------------------------------------------------------------
int logic_calc(char* word)
{
	int val[255];
	int ope[255];
	int wordlen;
	char *w;
	int sp1,sp2;
	
	wordlen = strlen(word);
	printf("wordlen:%d\n",wordlen);
//	logic_calc("(1|0)&1");
	w = word;
	sp1 =0;
	sp2 =0;
	
		val[0]=0;
		ope[0]=0;
		while(*w != '\0'){
			if(*w == '0' || *w == '1'){
				val[++sp2] = *w - '0';
//				printf("1val[%d]:%d\n",sp2,val[sp2]);
			}else{
				while((*w != '(' && *w != '!') && (ope[sp1] == '&' || ope[sp1] == '|' || ope[sp1] == '!' || ope[sp1] == '^')){
//					printf("1ope[%d]:%c\n",sp1,ope[sp1]);
					switch(ope[sp1]){
						case '&':
							val[sp2-1] = val[sp2-1] & val[sp2];
//							printf("2val[%d]:%d\n",sp2-1,val[sp2-1]);
							break;
						case '|':
							val[sp2-1] = val[sp2-1] | val[sp2];
//							printf("3val[%d]:%d\n",sp2-1,val[sp2-1]);
							break;
						case '^':
							val[sp2-1] = val[sp2-1] ^ val[sp2];
//							printf("3val[%d]:%d\n",sp2-1,val[sp2-1]);
							break;
						case '!':
							val[sp2] = ! val[sp2];
//							printf("3.3val[%d]:%d\n",sp2-1,val[sp2-1]);
							break;
					}
					sp2--;
					sp1--;
				}
				if((*w!=')')){
					ope[++sp1] = *w;
//					printf("2ope[%d]:%c\n",sp1,*w);
				}else{
					sp1--;
//					printf("3ope[%d]:%c\n",sp1,*w);
				}
			}
			w++;
		}
		while(sp1>0){
					switch(ope[sp1]){
						case '&':
							val[sp2-1] = val[sp2-1] & val[sp2];
//							printf("4val[%d]:%d\n",sp2-1,val[sp2-1]);
							break;
						case '|':
							val[sp2-1] = val[sp2-1] | val[sp2];
//							printf("5val[%d]:%d\n",sp2-1,val[sp2-1]);
							break;
						case '^':
							val[sp2-1] = val[sp2-1] ^ val[sp2];
//							printf("3val[%d]:%d\n",sp2-1,val[sp2-1]);
							break;
						case '!':
							val[sp2] = ! val[sp2];
//							printf("3.3val[%d]:%d\n",sp2-1,val[sp2-1]);
							break;
					}
					sp2--;
					sp1--;
		}
			
		printf("%s = %d\n",word,val[1]);

	return(val[1]);
}

//---------------------------------------------------------------------------
//		
//
//		n			IN		
//		int return	OUT		0`(n-1)̗
//---------------------------------------------------------------------------
int nasino_random(int n)
{
	int rand_tmp;

	if(n <= 1){
		rand_tmp = 0;
	}else{
		rand_tmp = rand() % (n);
	}

	return(rand_tmp);
}

//---------------------------------------------------------------------------
//	S-JISPoCgڂ̃`FbN
//	[_[oCg		0x81-0x9F, 0xE0-0xEF, 0xF0-0xFC*
//	g[[oCg	0x40-0x7E, 0x80-0xFC		
//
//	unsigned char sym	IN		`FbNR[h(1byte)
//	int ret				OUT		OK : S-JIS1byte
//								NG : ł͂Ȃ
//---------------------------------------------------------------------------
int checksjcode(unsigned char sym)
{
	int ret;

	if(((sym >= 0x81) && (sym <= 0x9f)) || ((sym >= 0xE0) && (sym <= 0xEF)) || ((sym >= 0xF0) && (sym <= 0xFC))){
		ret = OK;
	}else{
		ret = NG;
	}

	return(ret);
}

//---------------------------------------------------------------------------
//		̌
//			strstr()݊BbyteƂłȂAPʂŏB
//			Shift-JISp
//---------------------------------------------------------------------------
char* strstr2(char* word,char* tagword)
{
	unsigned int tagword_len;
	unsigned int wordtmp_len;
	char wordtmp0[WordLength];
	char wordtmp[WordLength];
	char *ret = NULL;
//	int cheki;
	unsigned int count0;
	unsigned int count1;
//	unsigned int count2;
//	int byteflug;
	int loop;
	
	tagword_len = strlen(tagword);
//	printf("tagword_len:%d\n",tagword_len);
	strcpy(wordtmp0,word);
	loop = ON;
	count0=0;
	while(tagword_len<=strlen(wordtmp0) && loop == ON){
		count1=0;
//		count2=0;
		strcpy(wordtmp,"");
		while((tagword_len > count1)/* &&(strlen(wordtmp0)>count1)*/){
			wordtmp_len = strlen(wordtmp);
			if(checksjcode(*(&wordtmp0[count1])) == OK){				// Po
				memcpy(&wordtmp[wordtmp_len],&wordtmp0[count1],2);
				wordtmp[wordtmp_len+2] = '\0';
				count1 = count1 + 2;
//				count2 = count2 + 2;
			}else{
				memcpy(&wordtmp[wordtmp_len],&wordtmp0[count1],1);
				wordtmp[wordtmp_len+1] = '\0';
				count1 ++;
//				count2 ++;
			}
		}
//		printf("wordtmp fin:%s:%s\n",wordtmp,wordtmp0);
//		sprintf(LogTmp,"wordtmp fin:%s:%s\n",wordtmp,wordtmp0);
//		logwrite(LogTmp);
		if(strcmp(wordtmp,tagword) == 0){
			loop = OFF;
			ret = &word[count0];
//			printf("cheki OK:%s\n",wordtmp);
//			logwrite("cheki OK\n");
		}
		
		if(checksjcode(*(&wordtmp0[0])) == OK){
			strcpy(&wordtmp0[0],&wordtmp0[2]);
			count0+=2;
		}else{
			strcpy(&wordtmp0[0],&wordtmp0[1]);
			count0++;
		}
		
/*		
		memcpy(wordtmp,&word[count1],tagword_len);
		wordtmp[tagword_len] = '\0';
		if((count1 != 0) && (tagword_len == 1)){
			if(checksjcode(*(&word[count1-1])) == NG){
				cheki = ON;
				printf("wordtmp OK:%s\n",wordtmp);
			}else{
				cheki = OFF;									// 2byte2byteڂn܂Ă;
				printf("wordtmp NG:%s\n",wordtmp);
			}
		}else{
			cheki = ON;
			printf("wordtmp OK:%s\n",wordtmp);
		}
	
		if(cheki == ON){
			if(strcmp(wordtmp,tagword) == 0){
				loop = OFF;
				ret = &word[count1];
				printf("cheki OK:%s\n",wordtmp);
			}
		}
*/
	}
	
//	sprintf(LogTmp,"strstr2_sub:%d : %s : %s\n",count0,word,ret);
//	logwrite(LogTmp);
	
//	return(strstr(word,tagword));
	return(ret);
}

